#ifndef BUILDERS_H
#define BUILDERS_H

#include <X11/Intrinsic.h>
#include "tree.h"

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)

extern void build_message( entry*, Widget );
extern void build_button( entry*, Widget, char* );
extern void build_slider( entry*, Widget, char* );
extern void build_dialog( entry*, Widget );
extern void build_text( entry*, Widget, char* );
extern void build_menubutton( entry*, Widget );
extern void build_list( entry*, Widget );
extern void build_choice( entry*, Widget );
extern void build_variable( entry*, Widget, char* );
extern void build_graph( entry*, Widget );
extern void build_grid( entry*, Widget, char* );
extern void build_timer( entry*, Widget );

extern int SetTag( Widget, Arg*, int*, char*, char* );
extern void common_tags( Widget, entry*, Arg*, int*, int );

#else

extern void build_message();
extern void build_button();
extern void build_slider();
extern void build_dialog();
extern void build_text();
extern void build_menubutton();
extern void build_list();
extern void build_choice();
extern void build_variable();
extern void build_graph();
extern void build_grid();
extern void build_timer();

extern void common_tags();
extern int SetTag();

#endif

#define SET_SIZE 1
#define SET_POSITION 2
#define SET_ORIENT 4
#define SET_COLOR 8
#define SET_FONT 16
#define SET_BITMAP 32
#define SET_EDIT 64
#define SET_SENSE 128
#define SET_FORM 256
#define SET_STATE 512
#define SET_PIXMAP 1024
#define SET_ALL 2047

#endif
