#ifndef OBJECT_H
#define OBJECT_H

#include <X11/Intrinsic.h>

#include "actions.h"

typedef struct objdef {
	char* name;
	action* action;
	char* value;
	Widget widgetname;
	void* info;
	void (*updater)();
	void (*sync)();
	struct objdef* next;
	} Objdef, *PObjdef; 

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)

extern Objdef* new_object();
extern Objdef* find_by_name( char*);
extern Objdef* find_by_widget( Widget );
extern char* get_string( char* );
extern void set_string( char*, char* );
extern void all_actions(void);

#else

extern Objdef* new_object();
extern Objdef* find_by_name();
extern Objdef* find_by_widget();
extern char* get_string();
extern void set_string();
extern void all_actions();

#endif

#endif
